#pragma once

#include "include/cef_app.h"

class BrowserClient;

class BrowserApp :
	public CefApp,
	public CefBrowserProcessHandler
{
public:
	friend class BrowserClient;
	friend class RenderProcessHandler;

	BrowserApp();
	~BrowserApp();

	virtual void OnBeforeCommandLineProcessing(const CefString& process_type, CefRefPtr<CefCommandLine> command_line);
	virtual CefRefPtr<CefBrowserProcessHandler> GetBrowserProcessHandler() OVERRIDE{ return this; }
	virtual CefRefPtr<CefRenderProcessHandler> GetRenderProcessHandler() OVERRIDE;
	virtual void OnContextInitialized() OVERRIDE;

	virtual void OnRenderProcessThreadCreated(CefRefPtr<CefListValue> extra_info) OVERRIDE;
	virtual void OnRegisterCustomSchemes(CefRefPtr<CefSchemeRegistrar> registrar) OVERRIDE;


	void Run();

	void SetInstanceId(int instanceId);
	int GetInstanceId();

	static BrowserApp& GetInstance() { return *instance; }

private:
	static CefRefPtr<BrowserClient> client;
	CefRefPtr<CefRenderProcessHandler> renderProcessHandler;
	int instanceId;

	static BrowserApp* instance;
	IMPLEMENT_REFCOUNTING(BrowserApp);
};
