#include "DisplayHandler.h"
#include "../BrowserClient.h"
#include "../../Views/View.h"
#include "../../Views/ViewManager.h"
#include "../../Views/Components/EventComponent.h"


DisplayHandler::DisplayHandler()
{
}


DisplayHandler::~DisplayHandler()
{
}


void DisplayHandler::OnTitleChange(CefRefPtr<CefBrowser> browser, const CefString& title)
{
	auto view = BrowserClient::GetInstance().GetViewManager().GetView(browser);
	if (view == nullptr)
		return;

	view->Events.OnTitleChanged(std::wstring(title));
}


void DisplayHandler::OnFaviconURLChange(CefRefPtr<CefBrowser> browser, const std::vector<CefString>& icon_urls)
{
	auto view = BrowserClient::GetInstance().GetViewManager().GetView(browser);
	if (view == nullptr)
		return;
	std::vector<std::wstring> urls;
	for (auto& url : icon_urls)
		urls.push_back(std::wstring(url));

	view->Events.OnFaviconURLChange(urls);
}
