#include "DownloadHandler.h"
#include "../BrowserClient.h"
#include "../../Views/View.h"
#include "../../Views/ViewManager.h"
#include "../../Views/Components/RequestComponent.h"

DownloadHandler::DownloadHandler()
{
}


DownloadHandler::~DownloadHandler()
{
}


void DownloadHandler::OnBeforeDownload(
	CefRefPtr<CefBrowser> browser,
	CefRefPtr<CefDownloadItem> download_item,
	const CefString& suggested_name,
	CefRefPtr<CefBeforeDownloadCallback> callback)
{
	auto view = BrowserClient::GetInstance().GetViewManager().GetView(browser);
	if (view == nullptr)
		return;

	auto url = download_item->GetURL();
	auto totalBytes = download_item->GetTotalBytes();

	callback->AddRef();
	view->Requests.RequestDownload(url, totalBytes, [callback](const DownloadRequestResult& downloadRequestResult) -> void
	{
		if (!downloadRequestResult.ShouldCancel)
		{
			callback->Continue(downloadRequestResult.Destination, false);
		}
		callback->Release();
	});
}


void DownloadHandler::OnDownloadUpdated(
	CefRefPtr<CefBrowser> browser,
	CefRefPtr<CefDownloadItem> download_item,
	CefRefPtr<CefDownloadItemCallback> callback)
{
}