#include "FocusHandler.h"
#include "../BrowserClient.h"
#include "../../Utils/StringHelper.h"
#include "../../Views/View.h"
#include "../../Views/ViewManager.h"
#include "../../Views/Components/EventComponent.h"


FocusHandler::FocusHandler()
{

}


FocusHandler::~FocusHandler()
{
}


void FocusHandler::OnGotFocus(CefRefPtr<CefBrowser> browser)
{
	auto windowHandle = browser->GetHost()->GetWindowHandle();
	auto isForegroundWindow = windowHandle == GetForegroundWindow();

	auto view = BrowserClient::GetInstance().GetViewManager().GetView(browser);
	if (view == nullptr)
		return;

	auto id = view->GetId();

	BrowserClient::GetInstance().GetViewManager().SetLastFocusedView(view->GetId());
	view->Events.OnGotFocus(isForegroundWindow);
}


void FocusHandler::OnTakeFocus(CefRefPtr<CefBrowser> browser, bool next)
{
}