#include "JSDialogHandler.h"
#include "../BrowserClient.h"
#include "../../Views/View.h"
#include "../../Views/ViewManager.h"
#include "../../Views/Components/RequestComponent.h"

JSDialogHandler::JSDialogHandler()
{
}


JSDialogHandler::~JSDialogHandler()
{
}


bool JSDialogHandler::OnJSDialog(CefRefPtr<CefBrowser> browser,
	const CefString& origin_url,
	const CefString& accept_lang,
	JSDialogType dialog_type,
	const CefString& message_text,
	const CefString& default_prompt_text,
	CefRefPtr<CefJSDialogCallback> callback,
	bool& suppress_message) 
{
	auto view = BrowserClient::GetInstance().GetViewManager().GetView(browser);
	if (view == nullptr)
		return false;

	view->Requests.DisplayDialog(origin_url, accept_lang, dialog_type, message_text, default_prompt_text, [callback](const DisplayDialogResult& result) -> void
	{
		callback->Continue(result.Success, result.UserInput);
	});

	return true;
}
