#include "KeyboardHandler.h"
#include "../DevToolsWebClient.h"
#include <fstream>


KeyboardHandler::KeyboardHandler()
{
	std::ifstream debugTxtFile(".\\debug.txt");
	if (debugTxtFile)
		debugMode = true;
	else
		debugMode = false;
#if DEBUG
	debugMode = true;
#endif
}

bool KeyboardHandler::OnKeyEvent(CefRefPtr<CefBrowser> browser, const CefKeyEvent& event, CefEventHandle os_event)
{
	if (debugMode)
	{
		auto keyCode = event.native_key_code;
		if (keyCode == 5767169 || keyCode == 5701633) // F12 || F12
		{
			CefPoint point;
			CefWindowInfo windowInfo;
			CefBrowserSettings settings;
			CefRefPtr<DevToolsWebClient> client = new DevToolsWebClient();

			windowInfo.SetAsPopup(browser->GetHost()->GetWindowHandle(), "DevTools");
			browser->GetHost()->ShowDevTools(windowInfo, client, settings, point);
		}
	}
	return false;
}
