#pragma once

#include "include/cef_client.h"
#include <list>

class BrowserClient;


class LifeSpanHandler :
	public CefLifeSpanHandler
{
public:
	LifeSpanHandler(BrowserClient &browserClient);
	virtual ~LifeSpanHandler();

	virtual void OnAfterCreated(CefRefPtr<CefBrowser> browser) OVERRIDE;
	virtual bool DoClose(CefRefPtr<CefBrowser> browser) OVERRIDE;
	virtual void OnBeforeClose(CefRefPtr<CefBrowser> browser) OVERRIDE;

	virtual bool OnBeforePopup(CefRefPtr<CefBrowser> browser,
		CefRefPtr<CefFrame> frame,
		const CefString& target_url,
		const CefString& target_frame_name,
		WindowOpenDisposition target_disposition,
		bool user_gesture,
		const CefPopupFeatures& popupFeatures,
		CefWindowInfo& windowInfo,
		CefRefPtr<CefClient>& client,
		CefBrowserSettings& settings,
		bool* no_javascript_access) OVERRIDE;

private:
	void ShowDevTools(CefRefPtr<CefBrowser> browser);
	void NotifyBrowserCreated(CefRefPtr<CefBrowser> browser);

private:

	IMPLEMENT_REFCOUNTING(LifeSpanHandler);
	BrowserClient &browserClient;
};

