#include "../BrowserClient.h"
#include "../../Views/ViewManager.h"
#include "../../Views/View.h"
#include "../../Views/Components/EventComponent.h"
#include "LoadHandler.h"
#include "include/wrapper/cef_helpers.h"

LoadHandler::LoadHandler()
{
}


LoadHandler::~LoadHandler()
{
}


void LoadHandler::OnLoadError(CefRefPtr<CefBrowser> browser, CefRefPtr<CefFrame> frame, ErrorCode errorCode, const CefString& errorText, const CefString& failedUrl)
{
	CEF_REQUIRE_UI_THREAD();

	auto view = BrowserClient::GetInstance().GetViewManager().GetView(browser);
	if (view == nullptr)
		return;

	if (errorCode == ERR_ABORTED)
		return;

	view->Events.OnLoadError(frame, errorCode, errorText, failedUrl);
}


void LoadHandler::OnLoadStart(CefRefPtr<CefBrowser> browser, CefRefPtr<CefFrame> frame)
{
	auto view = BrowserClient::GetInstance().GetViewManager().GetView(browser);
	if (view == nullptr)
		return;

	view->Events.OnLoadStart(frame);
}


void LoadHandler::OnLoadEnd(CefRefPtr<CefBrowser> browser, CefRefPtr<CefFrame> frame, int httpStatusCode)
{
	auto view = BrowserClient::GetInstance().GetViewManager().GetView(browser);
	if (view == nullptr)
		return;

	view->Events.OnLoadEnd(frame, httpStatusCode);
}


void LoadHandler::OnLoadingStateChange(CefRefPtr<CefBrowser> browser,
	bool isLoading,
	bool canGoBack,
	bool canGoForward)
{
	auto view = BrowserClient::GetInstance().GetViewManager().GetView(browser);
	if (view == nullptr)
		return;

	view->Events.OnLoadingStateChange(isLoading, canGoBack, canGoForward);
}
