#pragma once

#include "include\cef_render_process_handler.h"

class RenderProcessHandler :
	public CefRenderProcessHandler
{
public:
	RenderProcessHandler();
	virtual ~RenderProcessHandler();

	virtual void OnRenderThreadCreated(CefRefPtr<CefListValue> extra_info) OVERRIDE;

	virtual void OnBrowserCreated(CefRefPtr<CefBrowser> browser) OVERRIDE;
	virtual void OnBrowserDestroyed(CefRefPtr<CefBrowser> browser) OVERRIDE;
	
	virtual bool OnBeforeNavigation(CefRefPtr<CefBrowser> browser,
		CefRefPtr<CefFrame> frame,
		CefRefPtr<CefRequest> request,
		NavigationType navigation_type,
		bool is_redirect) OVERRIDE;

	virtual void OnContextCreated(CefRefPtr<CefBrowser> browser,
		CefRefPtr<CefFrame> frame,
		CefRefPtr<CefV8Context> context) OVERRIDE;

	virtual void OnContextReleased(CefRefPtr<CefBrowser> browser,
		CefRefPtr<CefFrame> frame,
		CefRefPtr<CefV8Context> context) OVERRIDE;

	virtual bool OnProcessMessageReceived(CefRefPtr<CefBrowser> browser,
		CefProcessId source_process,
		CefRefPtr<CefProcessMessage> message) OVERRIDE;

	virtual void OnWebKitInitialized() OVERRIDE;

	virtual void OnFocusedNodeChanged(CefRefPtr<CefBrowser> browser,
		CefRefPtr<CefFrame> frame,
		CefRefPtr<CefDOMNode> node) OVERRIDE;

private:
	CefRefPtr<CefV8Handler> siteKioskObjectHandler;
	int browserProcessId;

	void ApplyJavaScriptOverrideHandler(CefRefPtr<CefV8Context> context);
	void ApplyJavaScriptFullscreenFix(CefRefPtr<CefV8Context> context);

	void RegisterDevToolsExtension();
	void RegisterSiteKioskObjectExtension();

	IMPLEMENT_REFCOUNTING(RenderProcessHandler);
};
