#pragma once

#include <json/json-forwards.h>
#include <atomic>
#include "include\cef_resource_handler.h"

class SiteKioskResourceHandler :
	public CefResourceHandler
{
public:
	SiteKioskResourceHandler(CefRefPtr<CefFrame> frame);
	~SiteKioskResourceHandler();

	virtual bool ProcessRequest(CefRefPtr<CefRequest> request, CefRefPtr<CefCallback> callback);
	virtual void GetResponseHeaders(CefRefPtr<CefResponse> response, int64& response_length, CefString& redirectUrl);
	virtual bool ReadResponse(void* data_out, int bytes_to_read, int& bytes_read, CefRefPtr<CefCallback> callback);
	virtual void Cancel();

private:
	char *responseData;
	size_t responseDataLength;
	int64 pos;
	int viewId;
	CefRefPtr<CefFrame> frame;
	bool handled;

	std::wstring fileBaseDir;

	IMPLEMENT_REFCOUNTING(SiteKioskResourceHandler);
};

