#include "OverrideHandler.h"
#include "../../../Messages/BrowserRPCProcessor.h"

#include <iostream>
#include <json/json.h>


OverrideHandler::OverrideHandler()
{
}


OverrideHandler::~OverrideHandler()
{
}


void OverrideHandler::ApplyToContext(CefRefPtr<CefV8Handler> self, CefRefPtr<CefV8Context> context)
{
	auto object = context->GetGlobal();
	auto window = object->GetValue("window");
	window->SetValue("print", CefV8Value::CreateFunction("print", self), V8_PROPERTY_ATTRIBUTE_NONE);
	window->SetValue("close", CefV8Value::CreateFunction("close", self), V8_PROPERTY_ATTRIBUTE_NONE);
}


bool OverrideHandler::Execute(const CefString& name, CefRefPtr<CefV8Value> object, const CefV8ValueList& arguments, CefRefPtr<CefV8Value>& retval, CefString& exception)
{
	if (name == L"print")
	{
		auto context = CefV8Context::GetCurrentContext();

		BrowserRPCProcessor::Get(context->GetBrowser())->GetCommands().Print();

		return true;
	}
	else if (name == L"close")
	{
		return false;
	}

	return false;
}
