#pragma once
#include "include\cef_v8.h"
#include <map>
#include <mutex>

class SiteKioskObjectModel :
	public CefV8Handler
{
public:
	SiteKioskObjectModel();
	~SiteKioskObjectModel();

	virtual bool Execute(const CefString& name,
		CefRefPtr<CefV8Value> object,
		const CefV8ValueList& arguments,
		CefRefPtr<CefV8Value>& retval,
		CefString& exception) OVERRIDE;

private:
	std::map<std::wstring, bool> urlsWithObjectModelAccess;
	std::recursive_mutex mutex;

	std::wstring siteKioskScriptFileContent;

	bool CheckObjectModelAccess(CefRefPtr<CefV8Context> context);

	IMPLEMENT_REFCOUNTING(SiteKioskObjectModel);
};

