#pragma once
#include <string>
#include <sstream>
#include <windows.h>


class ExceptionDump
{
public:
	static void InitializeExceptionHandling();

	ExceptionDump(EXCEPTION_POINTERS* ep);
	~ExceptionDump();

	void Dump();

private:

	void OutputTraceToStream(const void* const* trace, size_t count, std::wstringstream& ss);

	std::wstring GenerateExceptionCodeString(DWORD code);
	std::wstring GetOpDescription(const ULONG opcode);
	void InitalizeSymbols();

private:
	EXCEPTION_POINTERS* ep;
};

