#include "Cancelable.h"


Cancelable::Cancelable(int id)
	: id(id)
{
}


Cancelable::Cancelable(int id, const std::function<void()>& onCancel)
	: onCancel(onCancel)
	, id(id)
{
}


void Cancelable::Cancel()
{
	if (onCancel)
		onCancel();
}

void Cancelable::Done()
{
	onCancel = nullptr;
}


void Cancelable::OnCancel(const std::function<void()>& onCancel, bool forceOverride)
{
	if (forceOverride)
	{
		this->onCancel = onCancel;
	}
	else
	{
		auto oldOnCancel = this->onCancel;
		this->onCancel = [oldOnCancel, onCancel]() -> void {
			oldOnCancel();
			onCancel();
		};
	}
}


int Cancelable::GetId()
{
	return id;
}
