#pragma once

#include "../Cancelable.h"
#include <json/json-forwards.h>
#include <string>
#include <functional>
#include <memory>
#include "windows.h"

class WebAppRPCProcessor;



class AppCommands
{
public:
	AppCommands(WebAppRPCProcessor &rpcProcessor);
	void Init();

	std::wstring GetString(const std::wstring& stringId);
	bool MustApplyObjectModel(const std::wstring& url, HANDLE exitEventHandle);
	
	void CancelRequest(int requestId);
	void OnAppReady();
	std::shared_ptr<Cancelable> OnCertificateError(int certError, const std::wstring& requestUrl, const std::function<void(bool)>& callback);
	void OnEditableNodeFocusChanged(bool isEditable);

protected:
	bool CreateEmptyViewHandler(const Json::Value& params, Json::Value& response);
	bool CreateViewHandler(const Json::Value& params, Json::Value& response);
	bool QuitHandler(const Json::Value& params, Json::Value& response);
	bool PingHandler(const Json::Value& params, Json::Value& response);
	bool SetLanguageHandler(const Json::Value& params, Json::Value& response);
	bool SetKeyboardLayoutHandler(const Json::Value& params, Json::Value& response);

private:
	WebAppRPCProcessor &rpcProcessor;
};

