#pragma once

#include <thread>
#include <queue>
#include <mutex>
#include "../Thread/ManualResetEvent.h"
#include "../Thread/AutoResetEvent.h"
#include "MessageProcessor.h"

#include "../NetPipe/NetPipeReader.h"
#include "../NetPipe/NetPipeWriter.h"

class NetPipeMessageProcessor
	: public MessageProcessor
{
public:
	NetPipeMessageProcessor(const std::wstring& sendTarget, const std::wstring& receiverName);
	virtual ~NetPipeMessageProcessor();
	virtual void Shutdown();
	virtual void Send(const std::wstring& message);

	virtual void Start();

	virtual void CreateNewSendTarget(const std::wstring& newSendTarget);

	std::wstring GetReceiverName() { return receiverName; }

protected:
	void RemoveNetPipeWriter(NetPipeWriter* writer);

private:
	std::mutex mutex;

	std::unique_ptr<NetPipeReader> reader;
	std::vector<std::shared_ptr<NetPipeWriter>> writers;
	std::wstring receiverName;
};