#pragma once

#include <thread>
#include <queue>
#include <mutex>
#include "../Thread/ManualResetEvent.h"
#include "../Thread/AutoResetEvent.h"
#include "MessageProcessor.h"

#include "../SharedMemory/IPCReader.h"
#include "../SharedMemory/IPCWriter.h"

class SharedMemoryMessageProcessor
	: public MessageProcessor
{
public:
	SharedMemoryMessageProcessor(const std::wstring& sendTarget, const std::wstring& receiverName);
	virtual ~SharedMemoryMessageProcessor();
	virtual void Shutdown();
	virtual void Send(const std::wstring& message);

	virtual void Start();

	virtual void CreateNewSendTarget(const std::wstring& newSendTarget);

	std::wstring GetReceiverName() { return receiverName; }

protected:
	void RemoveWriter(IPCWriter* writer);

private:
	std::mutex mutex;

	std::unique_ptr<IPCReader> reader;
	std::vector<std::shared_ptr<IPCWriter>> writers;
	std::wstring receiverName;
};