#pragma once

#include <thread>
#include <mutex>
#include "MessageProcessor.h"
#include "../Thread/ThreadPool.h"

class StdInOutMessageProcessor :
	public MessageProcessor
{
public:
	StdInOutMessageProcessor();
	virtual ~StdInOutMessageProcessor();
	virtual void Send(const std::wstring& message);

	virtual void Start();
	virtual void Shutdown();

private:
	void ProcessMessagesAsync();

private:
	std::mutex mutex;
	std::unique_ptr<std::thread> thread;
	std::unique_ptr<ThreadPool> threadPool;
	volatile bool shouldStop;
};
