#pragma once

#include <string>
#include <windows.h>

class MemoryMappedFile
{
public:
	class ViewAccessor
	{
		friend class MemoryMappedFile;
	private:
		ViewAccessor(char* mappedView);
	public:
		ViewAccessor(ViewAccessor&& other);
		~ViewAccessor();

		ViewAccessor& operator= (ViewAccessor other);
		char* Data() { return mappedView; }

	private:
		char* mappedView;
	};
public:
	MemoryMappedFile();
	MemoryMappedFile(MemoryMappedFile&& other);
	MemoryMappedFile(const std::wstring& name);
	MemoryMappedFile(const std::wstring& name, size_t capacity);
	~MemoryMappedFile();

	bool IsConnected() const { return handle != nullptr; }
	ViewAccessor CreateViewAccessor();

	MemoryMappedFile& operator= (MemoryMappedFile& other);

private:
	HANDLE handle;
};

