#include "Mutex.h"


Mutex::Mutex()
{
}


Mutex::Mutex(Mutex&& other)
	: Handle(std::move(other))
{
}


Mutex::Mutex(bool initiallyOwned, const std::wstring& name)
	: Handle(::CreateMutex(nullptr, initiallyOwned, name.c_str()))
{
}


DWORD Mutex::Wait(DWORD timeout)
{
	return ::WaitForSingleObject(GetHandle(), timeout);
}


void Mutex::ReleaseMutex()
{
	if (GetHandle() != nullptr)
		::ReleaseMutex(GetHandle());
}
