#pragma once

#include <map>
#include <vector>
#include <algorithm>
#include <string>

class CommandLine
{
public:
	static CommandLine& GetInstance();

	std::wstring GetStringArgument(const std::wstring& arg, const std::wstring &defaultValue = L"") const;
	bool GetBoolArgument(const std::wstring& arg, const bool &defaultValue = false) const;
	int GetIntArgument(const std::wstring& arg, const int &defaultValue = 0) const;
	long GetLongArgument(const std::wstring& arg, const long &defaultValue = 0) const;
	float GetFloatArgument(const std::wstring& arg, const float &defaultValue = 0.0f) const;
	const std::vector<std::wstring>& GetRawArguments() const;
private:
	CommandLine();
	const std::wstring* GetArgumentRaw(const std::wstring& arg) const;
	void ParseCommandLineArgument(const std::wstring& arg);

	std::map<std::wstring, std::wstring> parameters;
	std::vector<std::wstring> rawParameters;

	static CommandLine* instance;
};
