#include "Handle.h"
#include <utility>
#include <iostream>

Handle::Handle()
	: handle { nullptr }
{
}

Handle::Handle(HANDLE handle)
	: handle { handle }
{
}

Handle::Handle(Handle&& other)
	: handle(std::move(other.handle))
{
	other.handle = nullptr;
}


Handle::~Handle()
{
	Close();
}


Handle& Handle::operator= (HANDLE other)
{
	Close();
	handle = other;
	return *this;
}


void Handle::Close()
{
	if (handle != nullptr && handle != INVALID_HANDLE_VALUE)
		CloseHandle(handle);
	handle = nullptr;
}


Handle& Handle::operator = (Handle& other)
{
	std::swap(handle, other.handle);
	return *this;
}

HANDLE Handle::Release()
{
	auto tmp = handle;
	handle = nullptr;
	return tmp;
}
