#pragma once
#include <windows.h>

class Handle
{
public:
	Handle();
	Handle(HANDLE handle);
	Handle(Handle&& other);
	virtual ~Handle();

	void Close();

	HANDLE Release();

	bool operator !() const {
		return handle == INVALID_HANDLE_VALUE || handle == nullptr;
	}

	operator bool() const {
		return handle != INVALID_HANDLE_VALUE && handle != nullptr;
	}

	operator HANDLE() const { return handle; }
	Handle& operator= (Handle& other);
	Handle& operator= (HANDLE other);

protected:
	HANDLE GetHandle() const { return handle; }

private:
	HANDLE handle;

private:
	Handle(const Handle& other);
};

