#include "Profiler.h"
#include "Windows.h"
#include <sstream>


Profiler::Profiler(const std::wstring& name, bool measureOnDtor)
{
	Start(name, measureOnDtor);
}


Profiler::~Profiler()
{
	if (measureOnDtor)
		Stop();
}


void Profiler::Start(const std::wstring& name, bool measureOnDtor)
{
	this->name = name;
	this->measureOnDtor = measureOnDtor;
	start = HighResClock::now();
}


void Profiler::Stop() const
{
	auto end = HighResClock::now();
	auto duration = std::chrono::duration_cast<std::chrono::microseconds>(end - start).count();
	auto msDuration = (duration / 1000);

	std::wstringstream outputStringStream;
	outputStringStream << L"SKNG:CefApp: ";
	outputStringStream << L"Measured '" + name << L"': " << duration << L"us (" << msDuration << L"ms)" << std::endl;

	OutputDebugString(outputStringStream.str().c_str());
}


void Profiler::SetName(const std::wstring& name)
{
	this->name = name;
}
