﻿#include "StringHelper.h"

#include <string>
#include <iostream>
#include <clocale>
#include <locale>
#include <vector>

#include <codecvt>


std::wstring StringHelper::ToWString(const char* input)
{
	if (input == nullptr)
		return L"";
	return ToWString(std::string(input));
}


std::string StringHelper::ToAString(const wchar_t* input)
{
	if (input == nullptr)
		return "";
	return ToAString(std::wstring(input));
}


std::string StringHelper::ToAString(const std::wstring& input)
{
	return std::wstring_convert<std::codecvt_utf8<wchar_t>>().to_bytes(input);
}


std::wstring StringHelper::ToWString(const std::string& input)
{
	return std::wstring_convert<std::codecvt_utf8<wchar_t>>().from_bytes(input);
}


std::wstring StringHelper::ToWStringNoException(const std::string& input)
{
	std::wstring result;
	try
	{
		result = std::wstring_convert<std::codecvt_utf8<wchar_t>>().from_bytes(input);
	}
	catch (...)
	{
		result = std::wstring(input.begin(), input.end());
	}
	return result;
}
