#include "UriHelper.h"
#include "Windows.h"

std::wstring UriHelper::UnescapeDataString(const std::wstring& text)
{
	std::wstring result;
	for (unsigned i = 0; i < text.length(); i++)
	{
		if (int(text[i]) == 37)
		{
			int ii;
			swscanf_s(text.substr(i + 1, 2).c_str(), L"%x", &ii);
			auto ch = static_cast<char>(ii);
			result += ch;
			i = i + 2;
		}
		else {
			result += text[i];
		}
	}
	return result;
}


std::string UriHelper::UnescapeDataString(const std::string& text)
{
	std::string result;
	for (unsigned i = 0; i < text.length(); i++)
	{
		if (int(text[i]) == 37)
		{
			int ii;
			sscanf_s(text.substr(i + 1, 2).c_str(), "%x", &ii);
			auto ch = static_cast<char>(ii);
			result += ch;
			i = i + 2;
		}
		else {
			result += text[i];
		}
	}
	return result;
}

std::wstring UriHelper::EscapeDataString(const std::wstring& c)
{
	std::wstring escaped = L"";
	int max = c.length();
	for (int i = 0; i<max; i++)
	{
		if ((48 <= c[i] && c[i] <= 57) ||//0-9
			(65 <= c[i] && c[i] <= 90) ||//abc...xyz
			(97 <= c[i] && c[i] <= 122) || //ABC...XYZ
			(c[i] == L'~' || c[i] == L'!' || c[i] == L'*' || c[i] == L'(' || c[i] == L')' || c[i] == L'\'')
			)
		{
			escaped.append(&c[i], 1);
		}
		else
		{
			escaped.append(L"%");
			escaped.append(UriHelper::Char2Hex(c[i]));//converts char 255 to string "ff"
		}
	}
	return escaped;
}

std::wstring UriHelper::Char2Hex(wchar_t dec)
{
	wchar_t dig1 = (dec & 0xF0) >> 4;
	wchar_t dig2 = (dec & 0x0F);
	if (0 <= dig1 && dig1 <= 9) dig1 += 48;    //0,48inascii
	if (10 <= dig1 && dig1 <= 15) dig1 += 97 - 10; //a,97inascii
	if (0 <= dig2 && dig2 <= 9) dig2 += 48;
	if (10 <= dig2 && dig2 <= 15) dig2 += 97 - 10;

	std::wstring r;
	r.append(&dig1, 1);
	r.append(&dig2, 1);
	return r;
}