#pragma once

#include "Component.h"
#include <string>
#include <mutex>
#include <windows.h>

class DisplayComponent : public Component
{
public:
	DisplayComponent(View& view);

	void UpdateStyles();

	void SetTitle(const std::wstring& title);
	std::wstring GetTitle();

	void SetZoom(float zoom);
	float GetZoom();

	void SetShowInTaskbar(bool value);
	bool GetShowInTaskbar();

	void SetIsVisible(bool value);
	bool GetIsVisible();

	bool GetHasBorder();
	void SetHasBorder(bool hasBorder);

	void SetBrowserHandle(HWND handle);
	HWND GetBrowserHandle();
	
	float ConvertToZoomLevel(float zoom);

	void ChangeChildStyle(bool isChild);

private:
	std::recursive_mutex mutex;

	HWND browserHandle;
	bool hasBorders;
	long baseStyle;
	long baseExStyle;
	float zoom;
};

