#pragma once

#include "Component.h"
#include <string>
#include <map>
#include <windows.h>
//#include <mutex>

enum class NonClientAreaType
{
	Caption
};

enum class PopupHandlingMode
{
	DontOpen,
	OpenInCurrentView,
	OpenAsNewPopup
};

class InteractionComponent : public Component
{
public:
	InteractionComponent(View& view);

	void Focus();
	void Activate();

	void SetAllowInteraction(bool value);
	bool GetAllowInteraction();

	void SetIsCloseable(bool isCloseable);
	bool GetIsCloseable();

	PopupHandlingMode GetPopupHandling() const;
	void SetPopupHandling(PopupHandlingMode mode);

	void LoadUrl(const std::wstring& url, int frameId);
	std::wstring GetUrl();
	void Reload();
	bool GetCanGoForward();
	void Forward();
	bool GetCanGoBack();
	void Back();
	void Stop();

	void SetAllowContextMenu(bool value);
	bool GetAllowContextMenu();

	void SetAllowPrinting(bool value);
	bool GetAllowPrinting();
	void Print(const std::wstring& jobName);

	void ExecuteScript(const std::wstring& script);

	void StartFullscreen();
	void ExitFullscreen();

	void CheckNonClientAreaClick(int x, int y, HWND originalHwnd);
	void SetNonClientArea(NonClientAreaType type, int x, int y, int width, int height);

private:
	//std::recursive_mutex mutex;
	std::map<NonClientAreaType, RECT> nonClientAreas;

	bool allowContextMenu;
	bool isClosable;
	bool allowPrinting;
	PopupHandlingMode popupHandlingMode;
};

