#pragma once

#include "Component.h"
#include <windows.h>
#include <mutex>

class LayoutComponent : public Component
{
public:
	LayoutComponent(View& view);

	void SetPosition(int x, int y, bool isRelativePosition);
	void SetSize(int width, int height);
	void SetPositionAndSize(int x, int y, int width, int height, bool isRelativePosition);

	void SetMinSize(int width, int height);
	void SetMaxSize(int width, int height);
	SIZE GetMinSize() const;
	SIZE GetMaxSize() const;

	void SetWidth(int width);
	int GetWidth();

	void SetHeight(int height);
	int GetHeight();

	void SetLeft(int left);
	int GetLeft();

	void SetTop(int top);
	int GetTop();

	void SetRelativeLeft(int left);
	int GetRelativeLeft();

	void SetRelativeTop(int top);
	int GetRelativeTop();

	void SetParent(int parentViewId);
	int GetParent();

	void SetZIndex(int zIndex);
	int GetZIndex();

private:
	int minWidth;
	int minHeight;
	int maxWidth;
	int maxHeight;
	int parentViewId;
	int zIndex;
	std::recursive_mutex mutex;

};

