#include "PingComponent.h"
#include "../View.h"
#include "../../Browser/BrowserClient.h"
#include "../../Messages/BrowserRPCProcessor.h"
#include <algorithm>


PingComponent::PingComponent(View& view)
	: Component(view)
	, pongCallback([]() {})
{
}

PingComponent::~PingComponent()
{
	pongCallback();
}


void PingComponent::Ping(const std::function<void()>& pongCallback)
{
	this->pongCallback = pongCallback;
	if (view.GetViewReadyEvent().Wait(0) != WAIT_OBJECT_0)
		return;

	auto rpcProcessor = view.GetBrowserRPCProcessor();
	if (rpcProcessor != nullptr)
		rpcProcessor->GetCommands().Ping();
}


void PingComponent::Pong()
{
	pongCallback();
	pongCallback = []() {};
}
